#!/usr/bin/python

from PyQt4 import QtCore, QtGui, QtOpenGL

UNDEFINED_SIDE = 0
RECTANGULAR_SIDE = 1
SHARP_SIDE = 2

UNDEFINED_FRONT = 3
REGULAR_FRONT = 4
PILLAR_FRONT = 5

RECTANGULAR_ROOF = 6
SHARP_ROOF = 7

class HouseAttributes():
    def __init__(self):
        self.width = 0
        self.height = 0
        self.depth = 0
        self.roof_height = 0
        
        self.front_facade_type = UNDEFINED_FRONT
        self.side_facade_type = UNDEFINED_SIDE

        self.num_front_doors = 1
        self.num_back_doors = 0
        self.num_side_doors = 0

        self.door_width = 0
        self.door_height = 0

        self.num_front_wins = 0
        self.num_back_wins = 0
        self.num_side_wins = 0

        self.win_width = 0
        self.win_frame_width = 0
        self.win_frame_height = 0
        self.win_frame_base = 0

    def generate_attributes(self, lines):
        attr = HouseAttributes()
        attr.width = lines[0].line().length()
        attr.depth = lines[1].line().length()
        attr.height = 0.5 * attr.depth
        attr.roof_height = 0.5 * attr.height
        attr.num_front_doors = 1
        attr.door_height = 0.8 * attr.height
        attr.door_width = 0.5 * attr.door_height
        attr.num_front_wins = 0
        attr.num_side_wins = 0
        attr.num_back_wins = 0
        attr.win_width = 0.5 * attr.door_height
        attr.win_frame_width = 0.5 * attr.win_width
        attr.win_frame_height = 0.5 * attr.win_width
        attr.win_frame_base = 0.5 * attr.height

        return attr

class WallAttributes():
    def __init__(self):
        self.length = 0
        self.height = 20
        self.depth = 5

    def generate_attributes(self, lines):
        attr = WallAttributes()
        attr.length = round(lines[0].line().length())
        return attr

