#!/usr/bin/python

from OpenGL import GL
from shape import * 
from attributes import *
from basic_shapes import *

class IncaWall(Shape):
    def __init__(self, attr=None, id=-1):
        Shape.__init__(self)
        self.attr = attr
        self.id = id

        self.trans = [0, 0, 0]
        self.rot = 0

    def set_attr(self, attr):
        self.attr = attr

    def set_id(self, id):
        self.id = id

    def init_attr(self):
        pass

    def set_translation(self, trans):
        self.trans = trans

    def set_rotation(self, rot):
        self.rot = rot

    def generate(self):
        if self.attr == None:
            self.init_attr()

        self.length = self.attr.length
        self.height = self.attr.height
        self.depth = self.attr.depth

        self.front = Wall(self.length, self.height)
        self.back = Wall(self.length, self.height)
        self.left = Wall(self.depth, self.height)
        self.right = Wall(self.depth, self.height)
        self.top = Wall(self.length, self.depth)

    def render(self):
        GL.glMatrixMode(GL.GL_MODELVIEW)

        GL.glTranslate(self.trans[0], self.trans[1], self.trans[2])
        GL.glRotate(self.rot, 0, 1, 0)

        GL.glPushMatrix()
        GL.glTranslate(0.0, 0.0, 0.5 * self.depth)
        self.front.render()
        GL.glPopMatrix()
        
        GL.glPushMatrix()
        GL.glTranslate(0.0, 0.0, -0.5 * self.depth)
        self.back.render()
        GL.glPopMatrix()

        GL.glPushMatrix()
        GL.glTranslate(-0.5 * self.length, 0.0, 0)
        GL.glRotate(90, 0, 1, 0)
        self.left.render()
        GL.glPopMatrix()
        
        GL.glPushMatrix()
        GL.glTranslate(0.5 * self.length, 0.0, 0.0)
        GL.glRotate(-90, 0, 1, 0)
        self.right.render()
        GL.glPopMatrix()
        
        GL.glPushMatrix()
        GL.glTranslate(0.0, self.height, -0.5 * self.depth)
        GL.glRotate(90, 1, 0, 0)
        self.top.render()
        GL.glPopMatrix()
