#!/usr/bin/python

from OpenGL import GL

class Shape():
    def __init__(self):
        self.structure = []
        self.translation = []
        self.rotation = []

    def add_shape(self, shape, trans=[0, 0, 0], rot=[0, 0, 0]):
        self.structure.append(shape)
        self.translation.append(trans)
        self.rotation.append(rot)

    def clear(self):
        self.structure = []
        self.translation = []
        self.rotation = []

    def render(self):
        GL.glMatrixMode(GL.GL_MODELVIEW)
        GL.glPushMatrix()

        for i in xrange(len(self.structure)):
            trans = self.translation[i]
            rot = self.rotation[i]
            # TODO
            GL.glRotate(rot[0], 1, 0, 0)
            GL.glRotate(rot[1], 0, 1, 0)
            GL.glRotate(rot[2], 0, 0, 1)
            GL.glTranslate(trans[0], trans[1], trans[2])
            self.structure[i].render()

        GL.glPopMatrix()

