#!/usr/bin/python
from PyQt4 import QtCore
from math import *

def comp_house_trans(lines, width, height, model):
    x = 0
    z = 0
    for line in lines:
        l = line.line()
        x += 0.5 * (l.x1() + l.x2())
        z += 0.5 * (l.y1() + l.y2())
    
    x /= len(lines)
    z /= len(lines)
    y = model.get_height(x, z)

    # to world coord
    x -= 0.5 * width
    z -= 0.5 * height

    return [x, y, z]


def comp_house_rot(lines):
    line = lines[0].line()
    angle  = atan2(line.y2() - line.y1(), line.x2() - line.x1())
    if abs(angle) > 0.5 * pi and line.x1() > lines[2].line().x1():
        angle += pi
    if abs(angle) < 0.5 * pi and line.y1() < lines[2].line().y2():
        angle += pi
    return -angle * 180 / pi


def comp_wall_trans(lines, size, model):
    l1 = lines[0].line()
    x = 0.5 * (l1.x1() + l1.x2())
    z = 0.5 * (l1.y1() + l1.y2())
    y = model.get_height(x, z)

    # to world coord
    x -= 0.5 * size.width()
    z -= 0.5 * size.height() 

    return [x, y, z]

def comp_wall_rot(lines):
    #return -lines[0].line().angle(VERTICAL)
    line = lines[0].line()
    angle = atan2(line.y2() - line.y1(), line.x2() - line.x1())
    return -angle * 180 / pi


def comp_stairs(lines):
    '''
    coord: 
        |-------> x
        |
        |
        y
    '''
    long = lines[0].line()
    short = lines[1].line()

    angle = atan2(long.x2()-long.x1(), long.y2()-long.y1())
    start = (long.x1(), long.y1())
    end = (long.x1() + short.length(), long.y1() + long.length())
    if angle < 0: 
        end = (long.x1() - short.length(), long.y1() + long.length())

    return [-angle, start, end]
